<?php

namespace Drupal\codemirror_editor_test\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a Codemirror test form.
 */
class CodeMirrorEditorTestForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'codemirror_test_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    $options_1 = [];

    $form['editor_1'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Editor 1'),
      '#attributes' => [
        'data-code-mirror' => json_encode($options_1),
      ],
      '#rows' => 15,
    ];

    $options_2 = [
      'modeSelect' => [
        'text/html' => $this->t('HTML'),
        'javascript' => $this->t('JavaScript'),
        'css' => $this->t('CSS'),
      ],
      'lineNumbers' => TRUE,
      'autoCloseTags' => FALSE,
      'styleActiveLine' => TRUE,
      'buttons' => [
        'bold',
        'italic',
        'underline',
      ],
    ];

    $form['editor_2'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Editor 2'),
      '#attributes' => [
        'data-code-mirror' => json_encode($options_2),
      ],
    ];

    $options_3 = [
      'toolbar' => FALSE,
      'readOnly' => TRUE,
      'height' => 100,
      'foldGutter' => TRUE,
      'mode' => 'text/html',
    ];

    $form['editor_3'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Editor 3'),
      '#attributes' => [
        'data-code-mirror' => json_encode($options_3),
      ],
      '#default_value' => "<div>\n  Test\n</div>",
    ];

    $form['actions'] = ['#type' => 'actions'];
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Save'),
    ];

    $form['#attached']['library'][] = 'codemirror_editor/editor';

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    // Intentionally empty.
  }

}
